//---------------------------------------------------------------------------


#pragma hdrstop

#include "RelaxtionThread.h"
#include "RelaxtionModelInterface.h"


void __fastcall RelaxtionThread::Execute(void){
m_finished=false;
while (!m_finished) {
        m_relaxtionModel->relax();
        m_finished=m_relaxtionModel->is_finished();
        m_iterationNumber++;
        }
}

int RelaxtionThread::getIterationCounter(){
return m_iterationNumber;
}

bool RelaxtionThread::isFinished(){
 return m_finished;
}


__fastcall RelaxtionThread::RelaxtionThread(RelaxtionModelInterface* relaxtionModel) : TThread(true) {
m_relaxtionModel=relaxtionModel;
m_iterationNumber=0;

}


//---------------------------------------------------------------------------

#pragma package(smart_init)
