//---------------------------------------------------------------------------


#pragma hdrstop

#include "TieBrackingRelaxtionModelWithRandomInits.h"


#include "MapGraph.h"
#include "TieBrackingRelaxtionModelWithRandomInits.h"
//---------------------------------------------------------------------------

TieBrackingRelaxtionModelWithRandomInits::TieBrackingRelaxtionModelWithRandomInits(MapGraph* graph) : SimpleRelaxtionModelWithRandomInits(graph){
initGraph();

}

bool TieBrackingRelaxtionModelWithRandomInits::is_finished(){
int found=-1;
for (int i=0;i<m_graph->vertexCount() && found==-1;i++){
  bool amb=true;
  for (int j=0;j<m_graph->getWantedColorsCount();j++)
    amb=amb && m_graph->getVertexColorProbability(i,j)<0.95;

  if (amb) found=i;
}

if (found!=-1){
  int color_index=-1;
  double max_color=0;
  for (int j=0;j<m_graph->getWantedColorsCount();j++)
    if (max_color<m_graph->getVertexColorProbability(found,j)){
     max_color=m_graph->getVertexColorProbability(found,j);
     color_index=j;
     }

   for (int j=0;j<m_graph->getWantedColorsCount();j++)
     m_graph->setVertexColorProbability(found,j,0);
   m_graph->setVertexColorProbability(found,color_index,1);

 return false;
}
 else
  return SimpleRelaxtionModelWithRandomInits::is_finished();
}

//---------------------------------------------------------------------------

#pragma package(smart_init)
