//---------------------------------------------------------------------------

#ifndef SimpleRelaxtionModelH
#define SimpleRelaxtionModelH

#include "RelaxtionModelInterface.h"

class SimpleRelaxtionModel : public RelaxtionModelInterface{
protected:
double **m_tempProbabilities;

void virtual initGraph();
double virtual support(int vertexID,int color);
double virtual competability(int vertex1,int vertex2,int color1,int color2);
bool virtual is_finished();

public:
SimpleRelaxtionModel(MapGraph* graph);
void relax();


};



//---------------------------------------------------------------------------
#endif
