//---------------------------------------------------------------------------


#pragma hdrstop

#include "SimpleRelaxtionModelWithTwoColorsInit.h"
#include "MapGraph.h"


void  SimpleRelaxtionModelWithTwoColorsInit::initGraph(){
m_graph->setVertexColorProbability(0,0,1);
for (int i=1;i<m_graph->getWantedColorsCount();i++)
        m_graph->setVertexColorProbability(0,i,0);

int zerosFirstNbr=1;

for (;!m_graph->isNeighbors(zerosFirstNbr,0);zerosFirstNbr++);
for (int i=0;i<m_graph->getWantedColorsCount();i++)
        m_graph->setVertexColorProbability(zerosFirstNbr,i,0);
m_graph->setVertexColorProbability(zerosFirstNbr,1,1);


}


SimpleRelaxtionModelWithTwoColorsInit::SimpleRelaxtionModelWithTwoColorsInit(MapGraph* graph) : SimpleRelaxtionModel(graph){
initGraph();

}

//---------------------------------------------------------------------------

#pragma package(smart_init)
